using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.IO;

namespace SERT_UI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Button submitButton;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox licenseKey;
		private DataSet ds;
		private errorHandler.errors errors;
		private DataColumn dc3;
		private DataTable table;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ProgressBar progressBar;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			errors = new errorHandler.errors();
			try
			{
				Text = "Search Engine Ranking Tool";
				if(File.Exists(Environment.CurrentDirectory + @"\googleLicenseKey.txt"))
				{
					StreamReader reader = new StreamReader(Environment.CurrentDirectory + @"\googleLicenseKey.txt");
					licenseKey.Text = reader.ReadToEnd();
					reader.Close();
				}
				ds = new DataSet();
				ds.Tables.Add("SERT");
				table = ds.Tables["SERT"];
				DataColumn dc = new DataColumn("url");
				DataColumn dc2 = new DataColumn("keyword");
				dc3 = new DataColumn("ranking");
				table.Columns.Add(dc);
				table.Columns.Add(dc2);
				if(File.Exists(Environment.CurrentDirectory + @"\keywords.xml"))
				{
					ds.ReadXml(Environment.CurrentDirectory + @"\keywords.xml");
				}
				dataGrid1.AllowSorting = true;
				dataGrid1.ColumnHeadersVisible = true;
				DataView dv = table.DefaultView;
				//			DataGridTableStyle gridStyle = new DataGridTableStyle();
				//			gridStyle.MappingName = "Insured";
				//			dataGrid1.TableStyles.Add(gridStyle);
				//			gridStyle.GridColumnStyles["url"].Width = 250;
				//			gridStyle.GridColumnStyles["keyword"].Width = 250;
				//			gridStyle.GridColumnStyles["ranking"].Width = 250;
				//			gridStyle.DataGrid.Refresh();
				dataGrid1.DataSource = dv;
				MessageBox.Show("You must have a google api license key to use this tool.  Get one at: " +
					"http://api.google.com. Make sure to use the exact URL that is listed in google " +
					"for each page you are checking.  Don't forget the trailing slash at the end of the " +
					"URL.  The google API limits you to checking 100 keywords per day, and the results only " +
					"check 100 results deep.  If you see a 0 for the ranking, this means the keyword was " +
					"ranked over 100.");
			}
			catch(Exception ex)
			{
				errors.reportError("Error Encountered: " + ex.ToString());
			}
			if(errors.doErrorsExist())
			{
				MessageBox.Show(errors.readErrors());
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.submitButton = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.licenseKey = new System.Windows.Forms.TextBox();
			this.progressBar = new System.Windows.Forms.ProgressBar();
			this.label3 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(704, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Please enter the URLs and Keyword/Keyword Phrases You Wish To Check Your Google R" +
				"ankings On, Then Click \'Get Google Rankings!\'";
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(8, 64);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.PreferredColumnWidth = 220;
			this.dataGrid1.Size = new System.Drawing.Size(696, 432);
			this.dataGrid1.TabIndex = 1;
			// 
			// submitButton
			// 
			this.submitButton.Location = new System.Drawing.Point(568, 504);
			this.submitButton.Name = "submitButton";
			this.submitButton.Size = new System.Drawing.Size(128, 23);
			this.submitButton.TabIndex = 2;
			this.submitButton.Text = "Get Google Rankings!";
			this.submitButton.Click += new System.EventHandler(this.submitButton_Click);
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(16, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(144, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Google API License Key: ";
			// 
			// licenseKey
			// 
			this.licenseKey.Location = new System.Drawing.Point(160, 32);
			this.licenseKey.Name = "licenseKey";
			this.licenseKey.Size = new System.Drawing.Size(280, 20);
			this.licenseKey.TabIndex = 4;
			this.licenseKey.Text = "";
			// 
			// progressBar
			// 
			this.progressBar.Location = new System.Drawing.Point(80, 504);
			this.progressBar.Name = "progressBar";
			this.progressBar.Size = new System.Drawing.Size(480, 23);
			this.progressBar.TabIndex = 5;
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(8, 504);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "Progress:";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(712, 533);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label3,
																		  this.progressBar,
																		  this.licenseKey,
																		  this.label2,
																		  this.submitButton,
																		  this.dataGrid1,
																		  this.label1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void submitButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				StreamWriter swr = new StreamWriter(Environment.CurrentDirectory + @"\googleLicenseKey.txt", false);
				swr.Write(licenseKey.Text);
				swr.Close();
				progressBar.Visible = true;
				progressBar.Minimum = 1;
				progressBar.Maximum = ds.Tables["SERT"].Rows.Count;
				progressBar.Step = 1;
				progressBar.Value = 1;
				if(table.Columns.Count == 2)
				{
					table.Columns.Add(dc3);
				}
				int position = 0;
				googleCalls.Caller caller = new googleCalls.Caller(errors);
				foreach(DataRow row in ds.Tables["SERT"].Rows)
				{
					position = caller.getPosition((string)row["url"], 
						(string)row["keyword"], licenseKey.Text);
					if(position == 101)
					{
						row["ranking"] = 0;
					}
					else
					{
						row["ranking"] = position;
					}
					progressBar.PerformStep();
				}
				ds.WriteXml(Environment.CurrentDirectory + @"\keywords.xml");
			}
			catch(Exception ex)
			{
				errors.reportError("Error encountered: " + ex.ToString());
			}
			if(errors.doErrorsExist())
			{
				MessageBox.Show(errors.readErrors());
			}
		}
	}
}
